BILL = {}
BILL.DATA = {}

if SHARED.FRAMEWORK.ESX then
    ESX = exports['es_extended']:getSharedObject()
    ESX.PlayerData = ESX.GetPlayerData()
elseif SHARED.FRAMEWORK.QBCore then
    QBCore = exports['qb-core']:GetCoreObject()
end

RegisterNetEvent("Bill:Animation")
AddEventHandler("Bill:Animation", function()
    RequestAndWaitDict(SHARED.ANIM.GIVE.DICT)
    TaskAnim({SHARED.ANIM.GIVE.DICT, SHARED.ANIM.GIVE.NAME}, SHARED.ANIM.GIVE.TIME, SHARED.ANIM.GIVE.FLAG)
    PlaySoundFrontend(-1, SHARED.SOUND.NAME, SHARED.SOUND.REF, false)
end)

function Bill(DATA, REASON, AMOUNT, TYPE)
    local CLOSET_PLAYER = GetNearbyPlayer(false, true)

    if not CLOSET_PLAYER then 
        return
    end

    if SHARED.FRAMEWORK.ESX then
        if DATA == "society" and ESX.PlayerData.job.name == SHARED.UNEMPLOYED_JOB then ClearPedTasks(GetPlayerPed(-1)) return TriggerEvent("esx:showNotification", SHARED.LOCALE.UNEMPLOYED_ACCESS) end
    elseif SHARED.FRAMEWORK.QBCORE then
        local PLAYER = PlayerId()
        if DATA == "society" and QBCore.Functions.GetPlayer(GetPlayerServerId(PLAYER)).PlayerData.job == SHARED.UNEMPLOYED_JOB then ClearPedTasks(GetPlayerPed(-1)) return QBCore.Functions.Notify(SHARED.LOCALE.UNEMPLOYED_ACCESS, 'error', 5000) end
    end 

    TaskAnim(SHARED.ANIM.MAKE_BILL.NAME)

    if SHARED.FRAMEWORK.ESX then
        BILL.DATA = {
            TITLE = REASON,
            TYPE = TYPE,
            PRICE = AMOUNT,
            PLAYER_ID = GetPlayerServerId(CLOSET_PLAYER),
            SOLO = DATA == "personal" and true or false,
            ACCOUNT = DATA == "society" and "society_"..ESX.PlayerData.job.name
        }
    elseif SHARED.FRAMEWORK.QBCORE then 
        local PLAYER = PlayerId()

        BILL.DATA = {
            TITLE = REASON,
            TYPE = TYPE,
            PRICE = AMOUNT,
            PLAYER_ID = GetPlayerServerId(CLOSET_PLAYER),
            SOLO = DATA == "personal" and true or false,
            ACCOUNT = DATA == "society" and QBCore.Functions.GetPlayer(GetPlayerServerId(PLAYER)).PlayerData.job
        }
    end 

    TriggerServerEvent("Bill:Send", BILL.DATA)
    ClearPedTasks(GetPlayerPed(-1))
end

RegisterNetEvent("Bill:Get")
AddEventHandler("Bill:Get", function(BILL_DATA)
    if SHARED.FRAMEWORK.ESX then
        TriggerEvent("esx:showNotification", BillInfo(BILL_DATA))
        TriggerEvent("esx:showNotification", SHARED.LOCALE.ACCEPT_OR_REFUSE)
    elseif SHARED.FRAMEWORK.QBCore then
        QBCore.Functions.Notify(BillInfo(BILL_DATA), 'success', 5000)
        QBCore.Functions.Notify(SHARED.LOCALE.ACCEPT_OR_REFUSE, 'success', 5000)
    end 

    BILL.OnThread = false
    BILL.HavePayed = false
    BILL.OnThread = true

    Citizen.CreateThread(function()
        while true do 
            Wait(1)
            if BILL.OnThread and IsControlJustPressed(1, SHARED.CONTROL.ACCEPT) then 
                BILL.OnThread = false
                TriggerServerEvent("Bill:Pay", BILL_DATA)
                BILL.HavePayed = true
                break
            end
            if BILL.OnThread and IsControlJustPressed(1, SHARED.CONTROL.REFUSE) then 
                BILL.OnThread = false
                if SHARED.FRAMEWORK.ESX then
                    TriggerEvent("esx:showNotification", SHARED.LOCALE.REFUSE_RECEVEIR)
                    TriggerServerEvent("Bill:NotificationServer", BILL_DATA.SOURCE, SHARED.LOCALE.REFUSE_SENDER)
                elseif SHARED.FRAMEWORK.QBCore then
                    QBCore.Functions.Notify(SHARED.LOCALE.REFUSE_RECEVEIR, 'error', 5000)
                    TriggerServerEvent("Bill:NotificationServer", BILL_DATA.SOURCE, SHARED.LOCALE.REFUSE_SENDER)
                end 
                BILL.HavePayed = true
                break
            end
        end
    end)

    Citizen.Wait(10000)

    if not BILL.HavePayed then
        if SHARED.FRAMEWORK.ESX then
            TriggerEvent("esx:showNotification", SHARED.LOCALE.NEEDED_ACTION)
        elseif SHARED.FRAMEWORK.QBCore then
            QBCore.Functions.Notify(SHARED.LOCALE.NEEDED_ACTION, 'error', 5000)
        end 
        return
    end

    BILL.OnThread = false
    BILL.Data = {}
end)